#include "stdafx.h"
#include "FMOD.h"

FM::ListenerControl FM::Listener;

FM::ListenerControl& FM::ListenerControl::orn(C Vec &dir, C Vec &up) {
	_dir	= dir	;
	_up		= up	;
	return	T		;
}

FM::ListenerControl& FM::ListenerControl::pos(C Vec &pos, C Vec &vel) {
	_pos = pos;
	_vel = vel;
	return T	;
}

FM::ListenerControl& FM::ListenerControl::mute() {
	return pos(Vec(9999999999999999.0f));
}

void FM::ListenerControl::draw() {
	Vec l;
	l.x = _up.y * _dir.z - _up.z * _dir.y;
	l.y = _up.z * _dir.x - _up.x * _dir.z;
	l.z = _up.x * _dir.y - _up.y * _dir.x;
	Matrix m;
	m.pos = _pos;
	m.x = l;
	m.y = _up;
	m.z = _dir;
	SetMatrix();
	m.draw();
}
