#pragma once

	
namespace FM {

	struct geometryObject {
		// set
		geometryObject& pos(C Vec& position);
		geometryObject& active(Bool status);
		geometryObject& forward(C Vec& forward);
		geometryObject& up(C Vec& up);
		geometryObject& rotation(C Vec& forward, C Vec& up);
		geometryObject& scale(C Vec& scale);

		// get
		Vec pos();
		Bool active();

		// release memory
		void release();

		// for debugging purposes
		void draw(Color color=WHITE);

		// for internal use
		FMOD::Geometry * _object;
	};
}