/******************************************************************************
 * Copyright (c) yvan vander sanden.												                  *
 * Header file to wrap FMOD sound library in Esenthel Engine                  *
/******************************************************************************/

#pragma once

namespace FM {

	struct soundStruct {
		FMOD::Sound * sound;
		Str name;

		//operator for use with EE::memc
		Bool operator==(const soundStruct &other) const;
	};

	// utility conversion function 
	FMOD_VECTOR vecToFmod(C Vec &v);
	Vec fmodToVec(FMOD_VECTOR &v);
}