#pragma once
#include "sample.h"

namespace FM {
	namespace DSP {
		extern Int sampleRate;

		struct delay {
			
			delay& update(samplePtr& s);
			delay& set(						UInt size		);
			delay& get(sample& s, UInt delayTime);

			delay();
		 ~delay() { Free(buffer); }

		private:
			UInt bufferlength;
			Flt * buffer;
			Int phase;

			Int currentLength; // the sample length for this loop
			UInt size;
		};

	}
}