#pragma once
#include "sample.h"

#define MAXOVERLAP 32
#define INITVSTAKEN 64

namespace FM {
	namespace DSP {
		extern Int sampleRate;

		struct envelope {
			Flt operator()(); // get result
			envelope& set(Int window = 0, Int period = 0);
			Flt measure(samplePtr& s);

			envelope();
	   ~envelope();

		private:
			Int window;
			Int period;
			Int realPeriod;
			Int phase;
			Flt * buffer;
			Bool bufferExists;
			UInt currentBufferSize;
			Flt sumBuffer[MAXOVERLAP];

			// result
			Flt power;

		};

	}
}