#pragma once
#include "sample.h"

namespace FM {
	namespace DSP {
		extern Int sampleRate;
		
		struct ramp : sample {
			ramp& set(Flt target, Int time = 0);
			ramp& stop();

			ramp& update(samplePtr& s);
			Flt * operator()();
			Flt * getBuffer();
			Flt getValue();

			ramp();

		private:
			Flt target;
			Flt time;
			Flt current;
			Int ticksLeft;
			Bool reTarget;

			Flt _1overN;
			Flt _dspTickToMSEC;
			Flt inc, bigInc;

			//UInt currentBufferLength;
		};



	}
}