/* Not full programs, but small pieces of code that can come in handy. */


/* to update the listener object in a game, use something like this */
static Bool GameUpdate() {
	if (Players.elms()) {
		OrientP head = Players[0].cskel.getPoint("head");
		FM::Listener.orn(head.dir, head.perp);
		FM::Listener.pos(head.pos, Players[0].cskel.vel());
		Flt depth;
		if (Game::World.waterUnder(head.pos, &depth) != NULL) {
			FM::SoundSystem.underwater(true, depth);
		} else {
			FM::SoundSystem.underwater(false);
		}
	}

	FM::SoundSystem.update();
}

/* have a combobox from a gui window and populate it with available sound drivers */

Str DriverToString(Str &elm) { // I have my doubts about this one, but it works
	return elm;
}

void cAudioWindow::create() {
	if (obj.load("gui/obj/audio_options.gobj")) {
		driverBox = &obj.getComboBox("driver");
		driverBox->func(driverFunc);

		// setup listgroup and combobox contents
		ListGroup lg[] = { ListGroup(DriverToString, 1.0, L"Function") };
		driverBox->setGroups(lg, ELMS(lg), true);
		driverBox->setData(FM::SoundSystem.getDriverList());

		... other objects
}

/* For a reverb object created in the world editor.
	 Place the reverb enumeration in your enum folder! */	

// header file
struct cReverb : Game::Static {
private:
	Byte	type;
	FM::Reverb reverb;

public:
	void create(Game::ObjParams &obj);
};

// implementation
void cReverb::create(Game::ObjParams &obj) {
	__super::create(obj);

	if (Param * p = obj.findParam("type")) {
		type = p->asEnum();
		// create a new reverb object
		reverb.create(type);
		reverb.pos(this->pos());
		// get minimum and maximum distance
		if (Param * p2 = obj.findParam("MIN_DISTANCE")) {
			reverb.min(p2->asFlt());
		}
		if (Param * p3 = obj.findParam("MAX_DISTANCE")) {
			reverb.max(p3->asFlt());
		}
	}
}

// in the main game code
Game::ObjMemx<cReverb> Reverbs;

Game::World.init()
	 .setObjType(Reverbs, OBJ_REVERB)
	 .New("world/your.world");